#include "EPT_SGTool.h"


// include the SPI library
#include <SPI.h>

//Declare some int variables for use in the Loop()
int Channel;
int AnalogReadValue;

//Declare a Buffer for storing the ADC samples
int ChannelBuffer1[500] = {0};


void setup() 
{
  // Set the Analog 0 signal as an input
  pinMode (0, INPUT);
  
  AnalogReadValue = 0;
  Channel = 0;
  
  //Initialize the Serial Graph Tool
  EPT_SGToolInit();
  

}

void loop() 
{
  
  
   //Send the Channel selection at the beginning of each frame
   if(Channel > 5)
   {
        Channel = 0;
   }

  // go through for loop and incrementally send a count to SPI bus
  for( int count = 0; count < 451; count++)
  {
         //Sample the ADC Channel and add it to the 
         //Channel Buffer
         AnalogReadValue = analogRead(Channel); 
         ChannelBuffer1[count] =  AnalogReadValue;     
  }
  
  //Write the block of data to the Serial Graph Tool
  EPT_SGToolWriteBlockData(ChannelBuffer1, 450, Channel);

  //Send end of frame so the SGTool will plot the data
  EPT_SGToolFrameEnd();
  
  delay(20);
  
  //Increment the Channel
  Channel++;
  
}

