#include "EPT_SGTool.h"


// include the SPI library
#include <SPI.h>

//Declare some int variables for use in the Loop()
int Channel;
int Write_Channel;
int AnalogReadValue;
int LoopCycle0;
int LoopCycle1;

//Declare a Buffer for storing the ADC samples
int ChannelBuffer1[500] = {0};


void setup() 
{
  // Set the Analog 0 signal as an input
  pinMode (0, INPUT);
  
  AnalogReadValue = 0;
  Channel = 0;
  Write_Channel = 0;
  LoopCycle0 = 0;
  LoopCycle1 = 0;
  
  //Initialize the Serial Graph Tool
  EPT_SGToolInit();
  

}

void loop() 
{
  
  
   //Send the Channel selection at the beginning of each frame
   if(Channel > 3)
   {
        Channel = 0;
   }

  // go through for loop and incrementally send a count to SPI bus
  for( int count = 0; count < 451; count++)
  {
         //Sample the ADC Channel and add it to the 
         //Channel Buffer
         if(Channel == 0)
         {
             AnalogReadValue = LoopCycle0++;
             Write_Channel = 0;
         }
         else if(Channel == 1)
         {
             AnalogReadValue = LoopCycle1++;
             Write_Channel = 1;
         }
         else if(Channel == 2)
         {
             AnalogReadValue = analogRead(1);
             Write_Channel = 6;
         }
         else if(Channel == 3)
         {
             AnalogReadValue = analogRead(2);
             Write_Channel = 7;
         }
         //else
          //   AnalogReadValue = analogRead(Channel-2); 
         ChannelBuffer1[count] =  AnalogReadValue;   
       
         if(LoopCycle0 > 200)
             LoopCycle0 = 0;
             
         if(LoopCycle1 > 400)
             LoopCycle1 = 0;
  
  }
  
  //Write the block of data to the Serial Graph Tool
  EPT_SGToolWriteBlockData(ChannelBuffer1, 450, Write_Channel, TEN_BIT_DATA);

  //Send end of frame so the SGTool will plot the data
  EPT_SGToolFrameEnd();
  
  delay(20);
  
  //Increment the Channel
  Channel++;
  
}

