#include "EPT_SGTool.h"


// include the SPI library
#include <SPI.h>

//Declare some int variables for use in the Loop()
int Channel;
int AnalogReadValue;
int LoopCycle6;
int LoopCycle7;

//Declare a Buffer for storing the ADC samples
int ChannelBuffer1[500] = {0};


void setup() 
{
  // Set the Analog 0 signal as an input
  pinMode (0, INPUT);
  
  AnalogReadValue = 0;
  Channel = 0;
  LoopCycle6 = 0;
  LoopCycle7 = 0;
  
  //Initialize the Serial Graph Tool
  EPT_SGToolInit();
  

}

void loop() 
{
  
  
   //Send the Channel selection at the beginning of each frame
   if(Channel > 7)
   {
        Channel = 0;
   }

  // go through for loop and incrementally send a count to SPI bus
  for( int count = 0; count < 451; count++)
  {
         //Sample the ADC Channel and add it to the 
         //Channel Buffer
         if(Channel == 6)
             AnalogReadValue = LoopCycle6++;
         else if(Channel == 7)
             AnalogReadValue = LoopCycle7++;
         else
             AnalogReadValue = analogRead(Channel); 
         ChannelBuffer1[count] =  AnalogReadValue;   
       
         if(LoopCycle6 > 200)
             LoopCycle6 = 0;
             
         if(LoopCycle7 > 400)
             LoopCycle7 = 0;
  
  }
  
  //Write the block of data to the Serial Graph Tool
  EPT_SGToolWriteBlockData(ChannelBuffer1, 450, Channel, TEN_BIT_DATA);

  //Send end of frame so the SGTool will plot the data
  EPT_SGToolFrameEnd();
  
  delay(20);
  
  //Increment the Channel
  Channel++;
  
}

