﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Threading;

namespace HyperSerialPort
{

    public partial class frmChildForm : Form
    {
        public static string PropertiesPortName = "";
        public static string PropertiesBaudRate = "";
        public static string PropertiesDataBits = "";
        public static string PropertiesStopBits = "";
        public static string PropertiesHandshake = "";
        public static string PropertiesParity = "";

        public frmChildForm()
        {
            InitializeComponent();
            // Get a list of serial port names.
            string[] ports;
            ports = SerialPort.GetPortNames();

            if(!frm.Form2_EchoTransmitCharacters)
            {
                checkBoxForm2Echo.CheckState = CheckState.Checked;
            }

            if(frm.Form2_AddLineFeedCharacter)
            {
                checkBoxAddLineFeed.CheckState = CheckState.Checked;
            }

            if(frm.Form2_AppendLineFeed)
            {
                checkBoxAppendLineFeed.CheckState = CheckState.Checked;
            }

            if(frm.Form2_Force7bit)
            {
                checkBoxForce7bit.CheckState = CheckState.Checked;
            }

            if(frm.Form2_WrapLines)
            {
                checkBoxWrapLines.CheckState = CheckState.Checked;
            }

        // Display each port name to the console.
            foreach (string port in ports)
            {
                PortscomboBox.Items.Add(port);
            }
            PortscomboBox.Text = frm.Form2_PortName;
            //PropertiesPortName = frm.Form2_PortName;
            PropertiesBaudRate = frm.Form2_BaudRate;
            PropertiesDataBits = frm.Form2_DataBits;
            PropertiesStopBits = frm.Form2_StopBits;
            PropertiesHandshake = frm.Form2_Handshake;
            PropertiesParity = frm.Form2_Parity;
        }


        //creating object of parent to access shared variable  
        HyperSerialPort frm = new HyperSerialPort();
        //do not use .show method as we dont want to display the form  

        public string FormPropertiesPortName
        {
            get
            {
                return (PropertiesPortName);
            }
            set
            {
                PropertiesPortName = value;
            }
        }

        public string FormPropertiesBaudRate
        {
            get
            {
                return (PropertiesBaudRate);
            }
            set
            {
                PropertiesBaudRate = value;
            }
        }

        public string FormPropertiesDataBits
        {
            get
            {
                return (PropertiesDataBits);
            }
            set
            {
                PropertiesDataBits = value;
            }
        }

        public string FormPropertiesParity
        {
            get
            {
                return (PropertiesParity);
            }
            set
            {
                PropertiesParity = value;
            }
        }

        public string FormPropertiesStopBits
        {
            get
            {
                return (PropertiesStopBits);
            }
            set
            {
                PropertiesStopBits = value;
            }
        }

        public string FormPropertiesHandshake
        {
            get
            {
                return (PropertiesHandshake);
            }
            set
            {
                PropertiesHandshake = value;
            }
        }  

        private void btnClose_Click_1(object sender, EventArgs e)
        {
            this.Close();
        }

        private void buttonFindName_Click_1(object sender, EventArgs e)
        {
            //Clear the current list of ports
            PortscomboBox.Items.Clear();
            PortscomboBox.Text = "";

            // Get a list of serial port names.
            string[] ports;
            ports = SerialPort.GetPortNames();

            // Display each port name to the console.
            foreach (string port in ports)
            {
                //PortscomboBox.Text = port;
                PortscomboBox.Items.Add(port);
            }

        }

        private void PortscomboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            PropertiesPortName = PortscomboBox.Text;
        }

        private void SetPropertiesbutton_Click(object sender, EventArgs e)
        {
            ShowChildPropertiesForm();
        }
        public void ShowChildPropertiesForm()
        {
            //This instance allows communications with the child listbox.
            //frmChildForm newChildForm = new frmChildForm(this.listBox1);
            frmChildProperties newChildForm = new frmChildProperties();
            newChildForm.ShowDialog();
            newChildForm.Dispose();

            frm.Form2_propertiesCloseSerialPort = true;

        }

        private void buttonOk_Click(object sender, EventArgs e)
        {
            frm.Form2_PortName = PortscomboBox.Text;
            PropertiesPortName = PortscomboBox.Text;
            frm.Form2_BaudRate = PropertiesBaudRate;
            frm.Form2_DataBits = PropertiesDataBits;
            frm.Form2_Parity = PropertiesParity;
            frm.Form2_StopBits = PropertiesStopBits;
            frm.Form2_Handshake = PropertiesHandshake;
            Thread.Sleep(100);
            this.Close();
        }

        private void checkBoxForm2Echo_CheckedChanged(object sender, EventArgs e)
        {
            frm.Form2_EchoTransmitCharacters = !frm.Form2_EchoTransmitCharacters;
        }

        private void textBoxLineDelay_TextChanged(object sender, EventArgs e)
        {
            frm.Form2_LineDelay = Convert.ToInt32(textBoxLineDelay.Text);
        }

        private void textBoxCharDelay_TextChanged(object sender, EventArgs e)
        {
            frm.Form2_CharacterDelay = Convert.ToInt32(textBoxCharDelay.Text);
        }

        private void checkBoxAddLineFeed_CheckedChanged(object sender, EventArgs e)
        {
            frm.Form2_AddLineFeedCharacter = !frm.Form2_AddLineFeedCharacter;
        }

        private void checkBoxAppendLineFeed_CheckedChanged(object sender, EventArgs e)
        {
            frm.Form2_AppendLineFeed = !frm.Form2_AppendLineFeed;
        }

        private void checkBoxForce7bit_CheckedChanged(object sender, EventArgs e)
        {
            frm.Form2_Force7bit = !frm.Form2_Force7bit;
        }

        private void checkBoxWrapLines_CheckedChanged(object sender, EventArgs e)
        {
            frm.Form2_WrapLines = !frm.Form2_WrapLines;
        }



    }
}
