﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Threading;
using System.IO;

namespace HyperSerialPort
{
    public partial class frmReceiveFileForm : Form
    {
        string ChosenRecieveFile = "";
        TextWriter tw;

        //Flag to determine if Textwriter is open
        bool twOpen = false;
        public frmReceiveFileForm()
        {
            InitializeComponent();
        }

        //creating object of parent to access shared variable  
        HyperSerialPort frmSendFile = new HyperSerialPort();

        private void buttonRFOD_Click(object sender, EventArgs e)
        {
            openFDRecieveFile.InitialDirectory = "C:";
            openFDRecieveFile.Title = "Select the File to Open";
            openFDRecieveFile.FileName = "";
            openFDRecieveFile.Filter = "Send Text File|*.*";

            if (openFDRecieveFile.ShowDialog() == DialogResult.Cancel)
            {
                MessageBox.Show("Operation Cancelled");
            }
            else
            {
                ChosenRecieveFile = openFDRecieveFile.FileName;
                textBoxRFFilename.AppendText(ChosenRecieveFile);
            }
        }

        private void buttonRFStart_Click(object sender, EventArgs e)
        {
            try
            {
                serialPortReceiveFile.PortName = frmSendFile.Form2_PortName;
                serialPortReceiveFile.BaudRate = Convert.ToInt32(frmSendFile.Form2_BaudRate);
                serialPortReceiveFile.Parity = (Parity)Enum.Parse(typeof(Parity), frmSendFile.Form2_Parity);
                serialPortReceiveFile.DataBits = Convert.ToInt16(frmSendFile.Form2_DataBits);
                serialPortReceiveFile.StopBits = (StopBits)Enum.Parse(typeof(StopBits), frmSendFile.Form2_StopBits);
                serialPortReceiveFile.Handshake = (Handshake)Enum.Parse(typeof(Handshake), frmSendFile.Form2_Handshake); ;
                serialPortReceiveFile.Open();
                if (serialPortReceiveFile.IsOpen)
                {
                    // create a writer and open the file
                    tw = new StreamWriter(ChosenRecieveFile);

                    // write a line of text to the file
                    tw.WriteLine(serialPortReceiveFile.ReadExisting());

                    // close the stream
                    //tw.Close();
                    twOpen = true;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }

        private void buttonRFClose_Click(object sender, EventArgs e)
        {
            if (twOpen)
            {
                tw.Close();
                twOpen = false;
            }
            serialPortReceiveFile.Close();
            this.Close();
        }

        private void buttonRFCancel_Click(object sender, EventArgs e)
        {
            if (twOpen)
            {
                tw.Close();
                twOpen = false;
            }
            serialPortReceiveFile.Close();
            this.Close();

        }

        private void textBoxRFFilename_TextChanged(object sender, EventArgs e)
        {
            textBoxRFFilename.Text = ChosenRecieveFile;

        }
    }
}
